# -*- coding: UTF-8 -*-
import os
import re

def get_tags():
    return ['2', '2.1', '2.1.4']


def get_xml_namespace(node):
    pattern = re.compile(r'({\S+})(\S+)')
    m = pattern.match(node)
    if m:
        return m.groups()[0]
    else:
        return ''


def get_node_tag(node):
    pattern = re.compile(r'({\S+})*(\S+)')
    m = pattern.match(node)
    if m:
        return m.groups()[1]
    else:
        return ''


def run_task(runcontext):
    tomcat_home = runcontext.get_extra_var('TOMCAT_HOME')
    tomcat_home = runcontext.replace_inject_characters(tomcat_home)
    runcontext.log_debug("tomcat_home: %s" % tomcat_home)
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["systemvalue1"] = ''
    ret_code = -1
    ret_msg = ''
    file_list = ['webapps/js-examples', 'webapps/servlet-example', 'webapps/webdav', 'webapps/tomcat-docs', 'webapps/balancer', 'webapps/ROOT/admin', 'webapps/examples', 'server/webapps/host-manager', 'server/webapps/manager', 'conf/Catalina/localhost/host-manager.xml', 'conf/Catalina/localhost/manager.xml']
    ret_err_list = []

    for err_file in file_list:
        err_file = os.path.join(tomcat_home, err_file)
        if os.path.exists(err_file):
            ret_err_list.append(err_file)
            
    if ret_err_list:
        tmp_vars["systemvalue1"] = '\n'.join(ret_err_list)
    else:
        ret_code = 0
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["policyresult"] = "pass"
        tmp_vars["systemvalue1"] = ''

    curtemplate = runcontext.get_template()
    rc1, out = curtemplate.render(runcontext.get_template_file('r_2_1_4.j2'), **tmp_vars)

    if rc1 == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out

    return ret_code, ret_msg
