# -*- coding: UTF-8 -*-
import os
import re
import json

def get_tags():
    return ['2','2.2','2.2.1']


def run_task(runcontext):

    ret_code = -2
    ret_msg = '' 
    tmp_vars = {}
    tmp_vars['policyresult'] = 'failed'
    tmp_vars['checkresult1'] = 'failed'
    tmp_vars['checkvalue1'] = ''
    tmp_vars['checkresult3'] = 'failed'
    tmp_vars['checkvalue3'] = ''
    tmp_vars['checkresult4'] = 'failed'
    tmp_vars['checkvalue4'] = ''
    
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,'_ansible_module_name','xml_query')
    runcontext.set_mod_params_instance(ansible_params,'action',runcontext.get_parameter('action'))
    runcontext.set_mod_params_instance(ansible_params,'backupfile',os.path.join(runcontext.get_parameter('backup_path'),'r_2_2_1.json'))
    gwebxml = runcontext.get_extra_var('TOMCAT_GLOBAL_WEB_FILE')
    gserverxml = runcontext.get_extra_var('TOMCAT_GLOBAL_SERVER_FILE')
        
    runcontext.set_mod_params_instance(ansible_params,'path',gwebxml)
    runcontext.set_mod_params_instance(ansible_params,'xpath','.//{ns}init-param')
    runcontext.set_mod_params_instance(ansible_params,'content','element')
    runcontext.set_mod_params_instance(ansible_params,'value','')    
    module=runcontext.get_module_file('xml_query.py')
    rc1,stdout1,stderr1 = runcontext.invoke_module(module, ansible_params)
    runcontext.sleep()
    
   
    
    runcontext.set_mod_params_instance(ansible_params,'path',gserverxml)
    runcontext.set_mod_params_instance(ansible_params,'xpath','.//{ns}Connector')
    runcontext.set_mod_params_instance(ansible_params,'content','attribute')
    runcontext.set_mod_params_instance(ansible_params,'attribute','allowTrace')
    runcontext.set_mod_params_instance(ansible_params,'operation','include')
    runcontext.set_mod_params_instance(ansible_params,'value','true')  
    rc3,stdout3,stderr3 = runcontext.invoke_module(module, ansible_params)
    runcontext.sleep()
    
    runcontext.set_mod_params_instance(ansible_params,'path',gwebxml)
    runcontext.set_mod_params_instance(ansible_params,'xpath','.//{ns}security-constraint/{ns}web-resource-collection')
    runcontext.set_mod_params_instance(ansible_params,'content','text')
    runcontext.set_mod_params_instance(ansible_params,'value',"")  
    rc4,stdout4,stderr4 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(rc4, stdout4, stderr4)
    runcontext.sleep()

    resultjson1 = json.loads(stdout1)
    resultjson3 = json.loads(stdout3)
    resultjson4 = json.loads(stdout4)
    runcontext.log_debug(resultjson1)
    runcontext.log_debug(resultjson3)
    runcontext.log_debug(resultjson4)
    
    tmpFlag1 = True                                         #tmpFlag = True ,if include readonly false
    tmpFlag3 = True
    tmpMsg = []
    isTrue = False
    isTrue2 = True


    if 'failed' in resultjson1:
        ret_code = -2
        return ret_code,resultjson1['msg']
    else:
        result1All = resultjson1["items"]["values"]
        
        for result1 in result1All:
            if re.match(r'.*\>\s*readonly\s*\<', "".join(result1).replace("\n"," ")) and  re.match(r'.*\>\s*false\s*\<', "".join(result1).replace("\n"," ")):
                tmpFlag1 = False
            elif re.match(r'.*\>\s*readonly\s*\<', "".join(result1).replace("\n"," ")) and  re.match(r'.*\>\s*true\s*\<', "".join(result1).replace("\n"," ")):
                isTrue = True


    if 'failed' in resultjson3:
        ret_code = -2
        return ret_code,resultjson3['msg']
    else:        
        result = resultjson3['result']
        result3All = resultjson3["items"]["values"]
        if len(''.join(result3All)) == 0:
            isTrue2 = False

        if result == True:
            tmpFlag3 = False


    if 'failed' in resultjson4:
        ret_code = -2
        return ret_code,resultjson4['msg']
    else:        
        result4All = ''.join(resultjson4["items"]["values"])

        if "OPTIONS" in result4All:
            tmpMsg.append("OPTIONS")
        if "HEAD" in result4All:
            tmpMsg.append("HEAD")
        if "PUT" in result4All:
            tmpMsg.append("PUT")
        if "DELETE" in result4All:
            tmpMsg.append("DELETE")
        if "TRACE" in result4All:
            tmpMsg.append("TRACE")

    if tmpFlag1:
        tmp_vars['checkresult1'] = 'pass'
        if isTrue:
            tmp_vars['checkvalue1'] = 'readonly=true'
        else:
            tmp_vars['checkvalue1'] = ''
    else:
        tmp_vars['checkresult1'] = 'failed'
        tmp_vars['checkvalue1'] = 'readonly=false'
        
        
    if tmpFlag3:
        tmp_vars['checkresult3'] = 'pass'
        if isTrue2:
            tmp_vars['checkvalue3'] = 'allowTrace=false'
        else:
            tmp_vars['checkvalue3'] = ''
    else:
        tmp_vars['checkresult3'] = 'failed'
        tmp_vars['checkvalue3'] = 'allowTrace=true'
        
    if len(tmpMsg) == 5:
        tmp_vars['checkresult4'] = 'pass'        
    else:
        tmp_vars['checkresult4'] = 'failed'
        
    tmp_vars['checkvalue4'] = '%s' % (' '.join(tmpMsg))
            
    if tmp_vars['checkresult1'] == 'pass' and tmp_vars['checkresult3'] == 'pass' and tmp_vars['checkresult4'] == 'pass':
        tmp_vars['policyresult'] = 'pass'
        ret_code = 0
    else:
        ret_code = -1
    
    curtemplate = runcontext.get_template()
    rc1,out = curtemplate.render(runcontext.get_template_file('r_2_2_1.j2'),**tmp_vars)

    if rc1 == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out
        
    return ret_code,ret_msg
