# -*- coding: UTF-8 -*-
import os
import re
import json

def get_tags():
    return ['2', '2.2', '2.2.5']


def run_task(runcontext):

    ret_code = -2
    ret_msg = '' 
    tmp_vars = {}
    tmp_vars['policyresult'] = 'failed'
    tmp_vars['checkresult1'] = 'pass'
    tmp_vars['checkvalue1'] = ''
    totalFlag = False
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params, '_ansible_module_name', 'xml_query')
    runcontext.set_mod_params_instance(ansible_params, 'action', runcontext.get_parameter('action'))
    runcontext.set_mod_params_instance(ansible_params, 'backupfile', os.path.join(runcontext.get_parameter('backup_path'), 'r_2_2_5.json'))
    gwebxml = runcontext.get_extra_var('TOMCAT_GLOBAL_WEB_FILE')
        
    runcontext.set_mod_params_instance(ansible_params, 'path', gwebxml)
    runcontext.set_mod_params_instance(ansible_params, 'xpath', './/{ns}init-param')
    runcontext.set_mod_params_instance(ansible_params, 'content', 'element')
    runcontext.set_mod_params_instance(ansible_params, 'value', '')    
    module = runcontext.get_module_file('xml_query.py')
    rc1, stdout1, stderr1 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(rc1, stdout1, stderr1)
    runcontext.sleep()
    
    resultjson1 = json.loads(stdout1)
    
    if 'failed' in resultjson1:
        ret_code = -2
        return ret_code, resultjson1['msg']

    items = resultjson1['items']['values']
    runcontext.log_debug(items)
    for item in items:
        if re.match(".*listings.*false.*",''.join(item).replace("\n"," ")):
            totalFlag = True
            value = re.compile(r"xmlns:.+>")
            values = value.sub(">", ''.join(item).replace("ns0:", ""))
            tmp_vars['checkvalue1'] = ''.join(values)
            break

    if totalFlag:
        tmp_vars['checkresult1'] = 'pass'
    else:
        tmp_vars['checkresult1'] = 'failed'
        tmp_vars['checkvalue1'] = 'listings configuration is incorrect'
            
    if tmp_vars['checkresult1'] == 'pass':
        tmp_vars['policyresult'] = 'pass'
        ret_code = 0
    else:
        ret_code = -1
        
    curtemplate = runcontext.get_template()
    rc1, out = curtemplate.render(runcontext.get_template_file('r_2_2_5.j2'), **tmp_vars)

    if rc1 == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out
        
    return ret_code, ret_msg
