# -*- coding: UTF-8 -*-
import os
import json

def get_tags():
    return ['2','2.2','2.2.9']

def getOtherWebFiles(allwebs):
    owebs = []
    for webFile in allwebs:
        filelists = webFile.get('web.xml')
        if len(filelists) != 0: 
            filelists.pop()
        if len(owebs) == 0:
            owebs = filelists
        else:
            owebs.extend(filelists)
    return owebs

def run_task(runcontext):

    ret_code = -2
    ret_msg = '' 
    tmp_vars = {}
    tmp_vars['policyresult'] = 'failed'
    tmp_vars['checkvalue1'] = ''
    resultMsg = []
    resultList = []
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,'_ansible_module_name','xml_query')
    runcontext.set_mod_params_instance(ansible_params,'action',runcontext.get_parameter('action'))
    runcontext.set_mod_params_instance(ansible_params,'backupfile',os.path.join(runcontext.get_parameter('backup_path'),'r_2_2_9.json'))
    gwebxml = runcontext.get_extra_var('TOMCAT_GLOBAL_WEB_FILE')
    webxmls = getOtherWebFiles(runcontext.get_extra_var('TOMCAT_WEBAPPS'))
    webxmls.append(gwebxml)
    rwebs = webxmls[::-1]
    
    module=runcontext.get_module_file('xml_query.py')
    for webfile in rwebs:
        
        runcontext.set_mod_params_instance(ansible_params,'path',webfile)
        runcontext.set_mod_params_instance(ansible_params,'xpath','.//{ns}session-config/{ns}session-timeout')
        runcontext.set_mod_params_instance(ansible_params,'content','text')
        runcontext.set_mod_params_instance(ansible_params,'operation','match')
        runcontext.set_mod_params_instance(ansible_params,'value','(^10|[1-9]$)')    
        
        rc1,stdout1,stderr1 = runcontext.invoke_module(module, ansible_params)
        runcontext.sleep()
 
        resultjson1 = json.loads(stdout1)
        runcontext.log_debug_json(resultjson1)

        if 'failed' in resultjson1:
            ret_code = -2
            return ret_code,resultjson1['msg']

        values = "".join(resultjson1['items']['values'])

        if len(values) == 0:
            resultMsg.append('%s not configured' % webfile)
            resultList.append(False)
            continue

        if 'result' in resultjson1:
            result = resultjson1['result']
            if result == True:
                resultMsg.append('%s \n<session-config>\n        <session-timeout>%s</session-timeout>      \n</session-config>\n' % (webfile,values))
                resultList.append(True)
            else:
                resultMsg.append('%s \n<session-config>\n        <session-timeout>%s</session-timeout>      \n</session-config>\n' % (webfile,values))
                resultList.append(False)

    tmp_vars['checkvalue1'] = '\n'.join(resultMsg)
    ret_code = -1
    if False not in resultList:
        ret_code = 0
        tmp_vars['policyresult'] = 'pass'
    
    curtemplate = runcontext.get_template()
    rc1,out = curtemplate.render(runcontext.get_template_file('r_2_2_9.j2'),**tmp_vars)

    if rc1 == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out
        
    return ret_code,ret_msg
