# -*- coding: UTF-8 -*-
import os
import json

def get_tags():
    return ['2','2.5','2.5.1']

def run_task(runcontext):
    serverxml = runcontext.get_extra_var('TOMCAT_GLOBAL_SERVER_FILE')
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,'_ansible_module_name','xml_query')
    runcontext.set_mod_params_instance(ansible_params,'action',runcontext.get_parameter('action'))
    runcontext.set_mod_params_instance(ansible_params,'backupfile',os.path.join(runcontext.get_parameter('backup_path'),'r_2_5_1.json'))
    runcontext.set_mod_params_instance(ansible_params,'path',serverxml)
    
    runcontext.set_mod_params_instance(ansible_params,'xpath','.//{ns}Valve')
    runcontext.set_mod_params_instance(ansible_params,'content','attribute')
    runcontext.set_mod_params_instance(ansible_params,'attribute','className')
    runcontext.set_mod_params_instance(ansible_params,'operation','match')

    runcontext.set_mod_params_instance(ansible_params,'value','org.apache.catalina.valves.AccessLogValve')
    module=runcontext.get_module_file('xml_query.py')
    rc1,stdout1,stderr1 = runcontext.invoke_module(module, ansible_params)
    runcontext.sleep()


    resultjson1 = json.loads(stdout1)


    runcontext.log_debug_json(resultjson1)



    ret_code = -2
    ret_msg = ''    
    
    #run failed
    if 'failed' in resultjson1:
        ret_code = -2
        return ret_code,resultjson1['msg']

    
    tmp_vars = {}
    tmp_vars['policyresult'] = 'failed'
    tmp_vars['checkresult1'] = 'failed'
    tmp_vars['checkvalue1'] = " ".join(resultjson1['items']['values'])

    
    if 'result' in resultjson1:
        result = resultjson1['result']
        if result == True:
            tmp_vars['checkresult1'] = 'pass'
        else:
            tmp_vars['checkresult1'] = 'failed'

    
    if tmp_vars['checkresult1'] == 'pass':
        tmp_vars['policyresult'] = 'pass'
        ret_code = 0
    else:
        ret_code = -1 

    
    curtemplate = runcontext.get_template()
    rc1,out = curtemplate.render(runcontext.get_template_file('r_2_5_1.j2'),**tmp_vars)
    
    if rc1 == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out
        
    return ret_code,ret_msg
