# -*- coding: UTF-8 -*-
import os
import json

def get_tags():
    return ['2','2.9','2.9.1']

def run_task(runcontext):
    serverxml = runcontext.get_extra_var('TOMCAT_GLOBAL_SERVER_FILE')
    ansible_params = runcontext.get_mod_params_instance()   
    runcontext.set_mod_params_instance(ansible_params,'_ansible_module_name','xml_query')
    runcontext.set_mod_params_instance(ansible_params,'action',runcontext.get_parameter('action'))
    runcontext.set_mod_params_instance(ansible_params,'backupfile',os.path.join(runcontext.get_parameter('backup_path'),'s_2_9_1.json'))
    runcontext.set_mod_params_instance(ansible_params,'path',serverxml)
    
    runcontext.set_mod_params_instance(ansible_params,'xpath','.//{ns}Connector')
    runcontext.set_mod_params_instance(ansible_params,'content','attribute')
    runcontext.set_mod_params_instance(ansible_params,'attribute','maxSpareThreads')
    runcontext.set_mod_params_instance(ansible_params,'operation','match')

    runcontext.set_mod_params_instance(ansible_params,'value','^75$')
    module=runcontext.get_module_file('xml_query.py')
    rc1,stdout1,stderr1 = runcontext.invoke_module(module, ansible_params)
    runcontext.sleep()
    
    runcontext.set_mod_params_instance(ansible_params,'attribute','minSpareThreads')
    runcontext.set_mod_params_instance(ansible_params,'value','25')
    module=runcontext.get_module_file('xml_query.py')
    rc2,stdout2,stderr2 = runcontext.invoke_module(module, ansible_params)
    runcontext.sleep()

    runcontext.set_mod_params_instance(ansible_params, 'attribute',
                                       'maxThreads')
    runcontext.set_mod_params_instance(ansible_params, 'value', '150')
    module = runcontext.get_module_file('xml_query.py')
    rc3, stdout3, stderr3 = runcontext.invoke_module(module, ansible_params)
    runcontext.sleep()

    runcontext.set_mod_params_instance(ansible_params, 'attribute',
                                       'acceptCount')
    runcontext.set_mod_params_instance(ansible_params, 'value', '100')
    module = runcontext.get_module_file('xml_query.py')
    rc4, stdout4, stderr4 = runcontext.invoke_module(module, ansible_params)
    runcontext.sleep()

    resultjson1 = json.loads(stdout1)
    resultjson2 = json.loads(stdout2)
    resultjson3 = json.loads(stdout3)
    resultjson4 = json.loads(stdout4)

    runcontext.log_debug_json(resultjson1)
    runcontext.log_debug_json(resultjson2)
    runcontext.log_debug_json(resultjson3)
    runcontext.log_debug_json(resultjson4)

    ret_code = -2
    ret_msg = ''

    #run failed
    if 'failed' in resultjson1:
        ret_code = -2
        return ret_code,resultjson1['msg']
    if 'failed' in resultjson2:
        ret_code = -2
        return ret_code,resultjson2['msg']
    if 'failed' in resultjson3:
        ret_code = -2
        return ret_code,resultjson3['msg']
    if 'failed' in resultjson4:
        ret_code = -2
        return ret_code,resultjson4['msg']
    
    tmp_vars = {}
    tmp_vars['policyresult'] = 'failed'
    tmp_vars['checkresult1'] = 'failed'
    tmp_vars['checkresult2'] = 'failed'
    tmp_vars['checkresult3'] = 'failed'
    tmp_vars['checkresult4'] = 'failed'

    if "" in resultjson1['items']['values']:
        tmp_vars['checkvalue1'] = "Having the Connector without maxSpareThreads"
    else:
        tmp_vars['checkvalue1'] = " ".join(resultjson1['items']['values'])

    if "" in resultjson2['items']['values']:
        tmp_vars['checkvalue2'] = "Having the Connector without minSpareThreads"
    else:
        tmp_vars['checkvalue2'] = " ".join(resultjson2['items']['values'])

    if "" in resultjson3['items']['values']:
        tmp_vars['checkvalue3'] = "Having the Connector without maxThreads"
    else:
        tmp_vars['checkvalue3'] = " ".join(resultjson3['items']['values'])

    if "" in resultjson4['items']['values']:
        tmp_vars['checkvalue4'] = "Having the Connector without acceptCount"
    else:
        tmp_vars['checkvalue4'] = " ".join(resultjson4['items']['values'])


    if 'result' in resultjson1:
        result = resultjson1['result']
        if result == True:
            tmp_vars['checkresult1'] = 'pass'
        else:
            tmp_vars['checkresult1'] = 'failed'
            
    if 'result' in resultjson2:        
        result = resultjson2['result']
        if result == True:
            tmp_vars['checkresult2'] = 'pass'
        else:
            tmp_vars['checkresult2'] = 'failed'

    if 'result' in resultjson3:
        result = resultjson3['result']
        if result == True:
            tmp_vars['checkresult3'] = 'pass'
        else:
            tmp_vars['checkresult3'] = 'failed'

    if 'result' in resultjson4:
        result = resultjson4['result']
        if result == True:
            tmp_vars['checkresult4'] = 'pass'
        else:
            tmp_vars['checkresult4'] = 'failed'
    
    if tmp_vars['checkresult1'] == 'pass' and tmp_vars['checkresult2'] == 'pass' and tmp_vars['checkresult3'] == 'pass' and tmp_vars['checkresult4'] == 'pass':
        tmp_vars['policyresult'] = 'pass'
        ret_code = 0
    else:
        ret_code = -1 

    
    curtemplate = runcontext.get_template()
    rc1,out = curtemplate.render(runcontext.get_template_file('s_2_9_1.j2'),**tmp_vars)
    
    if rc1 == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out
        
    return ret_code,ret_msg
