# -*- coding: UTF-8 -*-
import re
import json

def get_tags():
    return ['2','2.1','2.1.2']


    
def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,"chdir",None)
    runcontext.set_mod_params_instance(ansible_params,"executable",None)

    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out

def run_audit(runcontext,ansible_params,module):
    
    ret_code = -1
    ret_msg = ''
    curtemplate=runcontext.get_template()
    tomcatbase = runcontext.get_extra_var('TOMCAT_BASE')
    tomcatbase = runcontext.replace_inject_characters(tomcatbase)
    runcontext.log_debug("tomcatbase: %s" % tomcatbase)
    
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["checkvalue1"] = ''
    tmp_vars["scancommand1"] = "ps -wo user,args -e | grep -v grep | grep  \"\-Dcatalina.base=%s\"" % tomcatbase

    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand1"])
    arc1,astdout1,astderr1=runcontext.invoke_module(module,ansible_params)
    runcontext.sleep()

    if arc1 != 0:
        return (-2, "Failed to invoke module: %s." % astdout1)

    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astderr1 = resultjson1["stderr"]

    runcontext.log_debug(resultjson1)

    match1_found=re.match("^$",astdout1)

    if match1_found:    # tomcat is not running
        ret_code = 0
        tmp_vars["policyresult"] = "pass"
        tmp_vars["checkresult1"] = "pass"
    else:
        tomcat_running_user = astdout1.split(' ', 1)[0].strip()
        tmp_vars["checkvalue1"] = astdout1
        if tomcat_running_user != "root":
            ret_code = 0
            tmp_vars["policyresult"] = "pass"
            tmp_vars["checkresult1"] = "pass"

    rc,out = curtemplate.render(runcontext.get_template_file('r_2_1_2.j2'), **tmp_vars)

    if rc == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out

    return ret_code,ret_msg