# -*- coding: UTF-8 -*-
import os
import xml.etree.ElementTree as ET

def get_tags():
    return ['2','2.1','2.1.3','2.1.3.1']

def run_task(runcontext):
    
    ret_code = -1
    ret_msg = ''
    curtemplate = runcontext.get_template()
    tomcatbase = runcontext.get_extra_var('TOMCAT_BASE')
    tomcatbase = runcontext.replace_inject_characters(tomcatbase)
    runcontext.log_debug("tomcatbase: %s" % tomcatbase)
    
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["checkvalue1"] = ''
    tmp_vars["checkresult2"] = "failed"
    tmp_vars["checkvalue2"] = ''
    tmp_vars["checkresult3"] = "failed"
    tmp_vars["checkvalue3"] = ''
    tmp_vars["checkresult4"] = "failed"
    tmp_vars["checkvalue4"] = ''

    #check 1:admin.xml manager.xml
    pWebapps = os.path.join(tomcatbase.rstrip(os.sep),'webapps')
    runcontext.log_debug("pWebapps: %s" % pWebapps)
    if False == os.path.exists(pWebapps):
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["checkresult4"] = "pass"
    else:
        if False == os.path.exists(os.path.join(pWebapps.rstrip(os.sep),'admin.xml')) and False == os.path.exists(os.path.join(pWebapps.rstrip(os.sep),'manager.xml')):
            tmp_vars["checkresult1"] = "pass"
        else:
            tmpStr = []
            if os.path.exists(os.path.join(pWebapps.rstrip(os.sep),'admin.xml')):
                tmpStr.append(os.path.join(pWebapps.rstrip(os.sep),'admin.xml'))
            if os.path.exists(os.path.join(pWebapps.rstrip(os.sep),'manager.xml')):
                tmpStr.append(os.path.join(pWebapps.rstrip(os.sep),'manager.xml'))
            tmp_vars["checkvalue1"] = '\n'.join(tmpStr)
        
        #check 4  admin manager  
        if False == os.path.exists(os.path.join(pWebapps,'admin')) and False == os.path.exists(os.path.join(pWebapps,'manager')):
            tmp_vars["checkresult4"] = "pass"
        else:
            tmpStr = []
            if os.path.exists(os.path.join(pWebapps.rstrip(os.sep),'admin')):
                tmpStr.append(os.path.join(pWebapps.rstrip(os.sep),'admin'))
            if os.path.exists(os.path.join(pWebapps.rstrip(os.sep),'manager')):
                tmpStr.append(os.path.join(pWebapps.rstrip(os.sep),'manager'))
            tmp_vars["checkvalue4"] = '\n'.join(tmpStr)
    
    #check 2
    pConf = os.path.join(tomcatbase.rstrip(os.sep),'conf')
    runcontext.log_debug("pConf: %s" % pConf)
    if False == os.path.exists(pConf):
        tmp_vars["checkresult2"] = "pass"
    else:
        pConfTomcatUsers = os.path.join(pConf.rstrip(os.sep),'tomcat-users.xml')
        if False == os.path.exists(pConfTomcatUsers):
            tmp_vars["checkresult2"] = "pass"
        else:
            xmlTree = ET.parse(pConfTomcatUsers)
            users = xmlTree.findall('./user')
            roles = xmlTree.findall('./role')
            if 0 == len(roles) and 0 == len(users):
                tmp_vars["checkresult2"] = "pass"
            else:
                tmpStr = []
                if 0 != users:
                    for user in users:
                        tmpStr.append("<%s ... />" % user)
                if 0 != roles:
                    for role in roles:
                        tmpStr.append("<%s ... />" % role)
                tmp_vars["checkvalue2"] = '\n'.join(tmpStr)
        
    #check 3
    pServer = os.path.join(tomcatbase.rstrip(os.sep),'server')
    runcontext.log_debug("pServer: %s" % pServer)
    if False == os.path.exists(pServer):
        tmp_vars["checkresult3"] = "pass"
    else:
        pServerWebapps = os.path.join(pServer.rstrip(os.sep),'webapps')
    
        if False == os.path.exists(pServerWebapps):
            tmp_vars["checkresult3"] = "pass"
        else:
            if False == os.path.exists(os.path.join(pServerWebapps,'admin')) and False == os.path.exists(os.path.join(pServerWebapps,'manager')):
                tmp_vars["checkresult3"] = "pass"
            else:
                tmpStr = []
                if os.path.exists(os.path.join(pServerWebapps.rstrip(os.sep),'admin')):
                    tmpStr.append(os.path.join(pServerWebapps.rstrip(os.sep),'admin'))
                if os.path.exists(os.path.join(pServerWebapps.rstrip(os.sep),'manager')):
                    tmpStr.append(os.path.join(pServerWebapps.rstrip(os.sep),'manager'))
                tmp_vars["checkvalue3"] = '\n'.join(tmpStr)    
 
    
    if  tmp_vars["checkresult1"] == "pass" and tmp_vars["checkresult2"] == "pass" and tmp_vars["checkresult3"] == "pass" and tmp_vars["checkresult4"] == "pass":
        tmp_vars["policyresult"] = "pass"
        ret_code = 0
        
    rc,out = curtemplate.render(runcontext.get_template_file('r_2_1_3_1.j2'),**tmp_vars)

    if rc == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out

    return ret_code,ret_msg
