# -*- coding: UTF-8 -*-
import os
import json

def get_tags():
    return ['2','2.1','2.1.5']


def run_task(runcontext):
  
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,'_ansible_module_name','file_permission')
    runcontext.set_mod_params_instance(ansible_params,'action',runcontext.get_parameter('action'))
    runcontext.set_mod_params_instance(ansible_params,'backupfile',os.path.join(runcontext.get_parameter('backup_path'),'r_2_1_5.json'))
    serverxml = runcontext.get_extra_var('TOMCAT_GLOBAL_SERVER_FILE')
    runcontext.set_mod_params_instance(ansible_params,'path',serverxml)
    runcontext.set_mod_params_instance(ansible_params,'xpath','.//{ns}Host')
    runcontext.set_mod_params_instance(ansible_params,'content','attribute')
    runcontext.set_mod_params_instance(ansible_params,'attribute','autoDeploy')
    runcontext.set_mod_params_instance(ansible_params,'operation','case insensitive equals')
    runcontext.set_mod_params_instance(ansible_params,'value','false')    
    
    module=runcontext.get_module_file('xml_query.py')
    rc1,stdout1,stderr1 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug(stdout1)
    runcontext.log_debug(stderr1)
    runcontext.sleep()
    
    runcontext.set_mod_params_instance(ansible_params,'attribute','deployOnStartup')
    runcontext.set_mod_params_instance(ansible_params,'operation','case insensitive equals')
    runcontext.set_mod_params_instance(ansible_params,'value','false')
    
    module=runcontext.get_module_file('xml_query.py')
    rc2,stdout2,stderr2 = runcontext.invoke_module(module, ansible_params)
    runcontext.sleep()
    runcontext.log_debug("stdout2:%s" % stdout2)
    runcontext.log_debug("stderr2:%s" % stderr2)
    
    resultjson1 = json.loads(stdout1)
    resultjson2 = json.loads(stdout2)
    
    ret_code = -2
    ret_msg = ''    
    
    #run failed
    if 'failed' in resultjson1:
        ret_code = -2
        return ret_code,resultjson1['msg']
    if 'failed' in resultjson2:
        ret_code = -2
        return ret_code,resultjson2['msg']
    
    tmp_vars = {}
    tmp_vars['policyresult'] = 'failed'
    tmp_vars['checkresult1'] = 'failed'
    tmp_vars['checkresult2'] = 'failed'
    tmp_vars['checkvalue1'] = ''
    tmp_vars['checkvalue2'] = ''
    
    if 'result' in resultjson1:
        result = resultjson1['result']
        values = resultjson1['items']['values'][0]
        if result == True:
            tmp_vars['checkresult1'] = 'pass'
            tmp_vars['checkvalue1'] = 'autoDeploy=false'
        else:
            tmp_vars['checkresult1'] = 'failed'
            if values == "true":
                tmp_vars['checkvalue1'] = 'autoDeploy=true'
            else:
                tmp_vars['checkvalue1'] = ''
            
    if 'result' in resultjson2:        
        result = resultjson2['result']
        values = resultjson2['items']['values'][0]
        if result == True:
            tmp_vars['checkresult2'] = 'pass'
            tmp_vars['checkvalue2'] = 'deployOnStartup=false'
        else:
            tmp_vars['checkresult2'] = 'failed'
            if values == "true":
                tmp_vars['checkvalue2'] = 'deployOnStartup=true'
            else:
                tmp_vars['checkvalue2'] = ''
    
    
    if tmp_vars['checkresult1'] == 'pass' and tmp_vars['checkresult2'] == 'pass':
        tmp_vars['policyresult'] = 'pass'
        ret_code = 0
    else:
        ret_code = -1
    
    curtemplate = runcontext.get_template()
    rc1,out = curtemplate.render(runcontext.get_template_file('r_2_1_5.j2'),**tmp_vars)
    
    if rc1 == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out
        
    return ret_code,ret_msg
