# -*- coding: UTF-8 -*-
import re
import json

def get_tags():
    return ['2','2.2','2.2.10']

    
def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,"chdir",None)
    runcontext.set_mod_params_instance(ansible_params,"executable",None)

    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out

def run_audit(runcontext,ansible_params,module):
    
    ret_code = -1
    ret_msg = ''
    curtemplate=runcontext.get_template()
    tomcatbase = runcontext.get_extra_var('TOMCAT_BASE')
    tomcatbase = runcontext.replace_inject_characters(tomcatbase)
    runcontext.log_debug("tomcatbase: %s" % tomcatbase)
    
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["checkvalue1"] = ''
    tmp_vars["scancommand1"] = "ps -wef | grep -v grep | grep \"\\-Dcatalina.base=%s\\s*\"  | egrep -i \"\\-Dorg\\.apache\\.catalina\\.connector\\.RECYCLE_FACADES\\s*=\\s*\" " % (tomcatbase)
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand1"])
    arc1,astdout1,astderr1=runcontext.invoke_module(module,ansible_params)
    runcontext.sleep()
    runcontext.log_debug("scancommand1 is: %s, astdout1 is: %s" % (tmp_vars["scancommand1"],astdout1))
    if arc1 != 0:
        return (-2, "Failed to invoke module: %s."%astdout1)

    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astderr1 = resultjson1["stderr"]

    runcontext.log_debug_json(resultjson1)
    match1_found = re.compile(r"(\-Dorg\.apache\.catalina\.connector\.RECYCLE_FACADES\s*=\s*)(\w{4,5}\s)")
    m1 = match1_found.findall(astdout1)
    if len(m1) <= 0:
        tmp_vars["checkvalue1"] = ''
    else:
        tmp_vars["checkvalue1"] = ''.join(m1[0])
        if 'true' == m1[0][1].rstrip():
            tmp_vars["policyresult"] = "pass"
            tmp_vars["checkresult1"] = "pass"
            ret_code = 0
        
    rc,out = curtemplate.render(runcontext.get_template_file('r_2_2_10.j2'),**tmp_vars)

    if rc == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out

    return ret_code,ret_msg
