# -*- coding: UTF-8 -*-
import xml.etree.ElementTree as ET

def get_tags():
    return ['2','2.2','2.2.11']


def run_task(runcontext):
    rc,out=run_audit(runcontext)
    return rc,out
    
def run_audit(runcontext):
    
    ret_code = 0
    ret_msg = ''
    
    curtemplate=runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["checkvalue1"] = ''
    
    ret_code = -2
    ret_msg = ''
    
    #get webapps
    webapps = runcontext.get_extra_var('TOMCAT_WEBAPPS')
    
    if webapps is None:
        return ret_code,'The webapps is none.'
    
    errMsg = ''
    for webapp in webapps:
        contexts = webapp['context.xml']
        host_name = webapp['host_name']
        context_path = webapp['context_path']
        auditresult = False
        
        #context.xml atleast have one
        if len(contexts) < 1:
            errMsg = '%s\n%s' % (errMsg,'Web App %s%s: context.xml does not exist.' % (host_name,context_path))
            continue
            
        #get the configuration value in the contexts in reverse order
        for context in contexts:
            
            xmlTree = ET.parse(context)
            nodeContext = xmlTree.getroot()
            if nodeContext.tag != 'Context':
                nodes = xmlTree.findall('.//Context')
                if len(nodes) == 0:
                    continue
                else:
                    #only check the first node
                    nodeContext = nodes[0]
            
            #if confg
            if 'crossContext' in nodeContext.attrib:
                value = nodeContext.attrib['crossContext']
                if value.lower() == 'true':
                    auditresult = False
                else:
                    auditresult = True
                    tmp_vars["checkvalue1"] = '<Context ... crossContext="false"/>'
            else:
                auditresult = True
                tmp_vars["checkvalue1"] = "<Context ... />"
                
        if auditresult == False:
            errMsg = '%s %s' % (errMsg,'Web App %s%s: <Context ... crossContext= "true" />' % (host_name,context_path))
    
    if errMsg != '':
        ret_code = -1
        tmp_vars["checkvalue1"] = errMsg
    else:
        ret_code = 0
        tmp_vars["policyresult"] = "pass"
        tmp_vars["checkresult1"] = "pass"
    
    curtemplate = runcontext.get_template()
    rc1,out = curtemplate.render(runcontext.get_template_file('r_2_2_11.j2'),**tmp_vars)
    
    
    
    if rc1 == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out
        
    return ret_code,ret_msg
