# -*- coding: UTF-8 -*-
import json

def get_tags():
    return ['2','2.2','2.2.12']


def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    rc,out=run_audit(runcontext,ansible_params)
    return rc,out
    
    
def run_audit(runcontext,ansible_params):

    tmp_vars = {}
    tmp_vars['policyresult'] = 'failed'
    tmp_vars['checkresult'] = 'failed'
    tmp_vars['checkvalue'] = ''

    contextxml = runcontext.get_extra_var('TOMCAT_GLOBAL_CONTEXT_FILE')
    runcontext.set_mod_params_instance(ansible_params,'path',contextxml)
    runcontext.set_mod_params_instance(ansible_params,'xpath','.')
    runcontext.set_mod_params_instance(ansible_params,'content','attribute')
    runcontext.set_mod_params_instance(ansible_params,'attribute','useHttpOnly')
    runcontext.set_mod_params_instance(ansible_params,'operation','not equal')
    runcontext.set_mod_params_instance(ansible_params,'value','false')    
    
    module=runcontext.get_module_file('xml_query.py')
    rc,stdout,stderr = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(rc, stdout, stderr)
    runcontext.sleep()
            
    resultjson = json.loads(stdout)
    
    runcontext.log_debug(resultjson)
    
    ret_code = -2
    ret_msg = ''
    
    #run failed
    if 'failed' in resultjson:
        ret_code = -2
        return ret_code,resultjson['msg']

    if 'result' in resultjson:
        result = resultjson['result']
        if result:
            ret_code = 0
            tmp_vars['checkresult'] = 'pass'
            tmp_vars['policyresult'] = 'pass'
            if len(''.join(resultjson['items']['values'])) == 0:
                tmp_vars['checkvalue'] = ''
            else:
                tmp_vars['checkvalue'] = 'useHttpOnly=true'
        else:
            ret_code = -1
            tmp_vars['checkresult'] = 'failed'
            tmp_vars['checkvalue'] = 'useHttpOnly=false'
     
    curtemplate = runcontext.get_template()
    rc1,out = curtemplate.render(runcontext.get_template_file('r_2_2_12.j2'),**tmp_vars)
    
    if rc1 == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out
        
    return ret_code,ret_msg
   
