# -*- coding: UTF-8 -*-
import xml.etree.ElementTree as ET

def get_tags():
    return ['2','2.2','2.2.13']

def run_task(runcontext):
    rc,out=run_audit(runcontext)
    return rc,out
    
    
def run_audit(runcontext):
    ret_code=-2
    serverxml = runcontext.get_extra_var('TOMCAT_GLOBAL_SERVER_FILE')
    if serverxml == None:
        return -2,'The Config file is not exist'
    rootnode=ET.parse(serverxml)
    Nodes=rootnode.findall(".//Connector")
    AttrportValue = "AJP/1.3 does not exist."
    for node in Nodes:
        ret_code=0
        AttrprotocolValue=node.get("protocol")
        if AttrprotocolValue != "AJP/1.3":
            continue
        AttrportValue=node.get("port")
        if AttrportValue == "8009":
            ret_code=-1
            break

    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult"] = "failed"
    tmp_vars["checkvalue"] = ''.join(AttrportValue)
    if ret_code == -1:
        tmp_vars["checkvalue"] = '<Connector port="8009" protocol="AJP/1.3" ... />'
    elif ret_code == 0:
        tmp_vars["policyresult"] = "pass"
        tmp_vars["checkresult"] = "pass"
        tmp_vars["checkvalue"] = ''.join(AttrportValue)

    curtemplate = runcontext.get_template()
    rc1,out = curtemplate.render(runcontext.get_template_file('r_2_2_13.j2'),**tmp_vars)

    if rc1 == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out
        
    return ret_code,ret_msg
   
