# -*- coding: UTF-8 -*-
import xml.etree.ElementTree as ET

def get_tags():
    return ['2','2.2','2.2.15']

def run_task(runcontext):
    rc,out=run_audit(runcontext)
    return rc,out
    
    
def run_audit(runcontext):
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    ret_code=-2
  
    rc1=CheckxPower(runcontext,tmp_vars)
    rc2=CheckServerAttr(runcontext,tmp_vars)
    if rc1 == 0 and rc2 == 0:
        ret_code=0
        tmp_vars["policyresult"] = "pass"
    elif rc1==-1 or rc2 == -1:
        ret_code=-1
    else:
        ret_code=-2
    curtemplate = runcontext.get_template()
    rc,out = curtemplate.render(runcontext.get_template_file('r_2_2_15.j2'),**tmp_vars)

    if rc == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out
        
    return ret_code,ret_msg

def CheckxPower(runcontext,tmp_vars):
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["checkvalue1"] = ""
    ret_code=-2
    serverxml = runcontext.get_extra_var('TOMCAT_GLOBAL_SERVER_FILE')
    if serverxml == None:
        return -2
    rootnode=ET.parse(serverxml)
    Nodes=rootnode.findall(".//Connector")
    for node in Nodes:
        ret_code=0
        AttrxPowerValue=node.get("xpoweredBy")
        if AttrxPowerValue == None:
            continue
        elif AttrxPowerValue.lower() == "true":
            ret_code=-1
            break
        elif AttrxPowerValue.lower() == "false":
            tmp_vars["checkvalue1"] = "xpoweredBy=false"
            continue
    
    if ret_code == -1:
        tmp_vars["checkvalue1"] = " Connector node is configured in %s and xpoweredBy is set to true." % (serverxml)
    elif ret_code == 0:
        tmp_vars["checkresult1"] = "pass"
          
    return ret_code
    
def CheckServerAttr(runcontext,tmp_vars):
    tmp_vars["checkresult2"] = "failed"
    tmp_vars["checkvalue2"] = ""
    ret_code=-2
    serverxml = runcontext.get_extra_var('TOMCAT_GLOBAL_SERVER_FILE')
    if serverxml == None:
        return -2
    rootnode=ET.parse(serverxml)
    Nodes=rootnode.findall(".//Connector")
    for node in Nodes:
        ret_code=0
        AttrproValue=node.get("protocol")

        if AttrproValue == None:
            ret_code=-1
            break
        if AttrproValue.upper().find("AJP") == 0:
            continue
        else:
            AttrServerValue=node.get("server") 
            if AttrServerValue == None:
                ret_code=-1
                break
            else:
                tmp_vars["checkvalue2"] = "server=%s" % AttrServerValue
                continue

    if ret_code == -1:
        tmp_vars["checkvalue2"] = ":HTTP Connector node in %s has no server attributes." % (serverxml)
    elif ret_code == 0:
        tmp_vars["checkresult2"] = "pass"

    return ret_code
   
