# -*- coding: UTF-8 -*-
import re
import json

def get_tags():
    return ['2','2.2','2.2.16']

    
def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,"chdir",None)
    runcontext.set_mod_params_instance(ansible_params,"executable",None)

    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out

def run_audit(runcontext,ansible_params,module):
    
    ret_code = -1
    ret_msg = ''
    curtemplate=runcontext.get_template()
    tomcatbase = runcontext.get_extra_var('TOMCAT_BASE')
    tomcatbase = runcontext.replace_inject_characters(tomcatbase)
    runcontext.log_debug("tomcatbase: %s" % tomcatbase)
    #init the result vars
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["checkvalue1"] = ''
    tmp_vars["checkresult2"] = "failed"
    tmp_vars["checkvalue2"] = ''
    tmp_vars["scancommand1"] = r'''ps -wef | grep -v grep | grep "\-Dcatalina.base=%s\s" | grep -i "\-Dorg\.apache\.catalina\.connector\.CoyoteAdapter\.ALLOW_BACKSLASH\s*=\s*" ''' % tomcatbase
    tmp_vars["scancommand2"] = r'''ps -wef | grep -v grep | grep "\-Dcatalina.base=%s\s" | grep -i "\-Dorg\.apache\.tomcat\.util\.buf\.UDecoder\.ALLOW_ENCODED_SLASH\s*=\s*" ''' % tomcatbase
    
    #call the shell module to check the key words
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand1"])
    arc1,astdout1,astderr1=runcontext.invoke_module(module,ansible_params)
    runcontext.sleep()
    if arc1 != 0:
        return (-2, "Failed to invoke module: %s."%astdout1)
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand2"])
    arc2,astdout2,astderr2=runcontext.invoke_module(module,ansible_params)
    runcontext.sleep()
    if arc2 != 0:
        return (-2, "Failed to invoke module: %s."%astdout2)

    #change the stdout to json format
    resultjson1 = json.loads(astdout1)
    resultjson2 = json.loads(astdout2)
    astdout1 = resultjson1["stdout"]
    astdout2 = resultjson2["stdout"]    

    #check the key value ,if there is no key word or the value is false then return success,else return failed
    match1_found = re.compile(r"(\-Dorg\.apache\.catalina\.connector\.CoyoteAdapter\.ALLOW_BACKSLASH\s*=\s*)(\w{4,5}\s)")
    m1 = match1_found.findall(astdout1)

    if len(m1) < 1:
        tmp_vars["checkvalue1"] = ''
        tmp_vars["checkresult1"] = "pass"

    else:
        tmp_vars["checkvalue1"] = ''.join(m1[0])
        if 'false' == m1[0][1].rstrip():
            tmp_vars["checkresult1"] = "pass"

        
    match2_found = re.compile(r"(?P<rule>\-Dorg\.apache\.tomcat\.util\.buf\.UDecoder\.ALLOW_ENCODED_SLASH\s*=\s*)(?P<logic>\w{4,5}\s)")
    m2 = match2_found.findall(astdout2)
    

    if len(m2) < 1:
        tmp_vars["checkvalue2"] = ''
        tmp_vars["checkresult2"] = "pass"

    else:
        tmp_vars["checkvalue2"] = ''.join(m2[0])
        if 'false' == m2[0][1].rstrip():
            tmp_vars["checkresult2"] = "pass"


    if tmp_vars["checkresult2"] == "pass" and tmp_vars["checkresult1"] == "pass":
        tmp_vars["policyresult"] = "pass"
        ret_code = 0
 
    rc,out = curtemplate.render(runcontext.get_template_file('r_2_2_16.j2'),**tmp_vars)

    if rc == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out

    return ret_code,ret_msg
   
