# -*- coding: UTF-8 -*-
import re

def get_tags():
    return ['2','2.2','2.2.17']

    
def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,"chdir",None)
    runcontext.set_mod_params_instance(ansible_params,"executable",None)

    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out

def run_audit(runcontext,ansible_params,module):
    
    ret_code = -1
    ret_msg = ''
    curtemplate=runcontext.get_template()
    tomcatbase = runcontext.get_extra_var('TOMCAT_BASE')
    tomcatbase = runcontext.replace_inject_characters(tomcatbase)
    runcontext.log_debug("tomcatbase: %s" % tomcatbase)
    #init the result vars
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult"] = "failed"
    tmp_vars["checkvalue"] = ''
    
    tmp_vars["scancommand"] = "ps -wef | grep -v grep | grep \"\-Dcatalina.base=%s\s\"" % tomcatbase + " | grep -i \"\-Dorg\.apache\.coyote\.USE_CUSTOM_STATUS_MSG_IN_HEADER\s*=\s*\""
    
    #call the shell module to check the key words
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand"])
    arc,astdout,astderr=runcontext.invoke_module(module,ansible_params)
    runcontext.sleep()
    if arc != 0:
        return (-2, "Failed to invoke module: %s."%astdout)

    #change the stdout to json format
    #check the key value ,if there is no key word or the value is false then return success,else return failed
    match1_found = re.compile(r"(\-Dorg\.apache\.coyote\.USE_CUSTOM_STATUS_MSG_IN_HEADER\s*=\s*)(\w{4,5}\s)")
    m1 = match1_found.findall(astdout)
    if len(m1) < 1:
        tmp_vars["checkvalue"] = ''
        tmp_vars["checkresult"] = "pass"
    else:
        tmp_vars["checkvalue"] = ''.join(m1[0])
        if 'false' == m1[0][1].rstrip():
            tmp_vars["checkresult"] = "pass"
            
    
    if tmp_vars["checkresult"] == "pass":
        tmp_vars["policyresult"] = "pass"
        ret_code = 0

       
    rc,out = curtemplate.render(runcontext.get_template_file('r_2_2_17.j2'),**tmp_vars)

    if rc == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out

    return ret_code,ret_msg
   
