# -*- coding: UTF-8 -*-
import xml.etree.ElementTree as ET

def get_tags():
    return ['2','2.2','2.2.18']

def run_task(runcontext):
    rc,out=run_audit(runcontext)
    return rc,out
    
def run_audit(runcontext):
    
    ret_code = 0
    ret_msg = ''
    auditresult = True
    
    curtemplate=runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult"] = "failed"
    tmp_vars["checkvalue"] = ''
    
    ret_code = -2
    ret_msg = ''
    
    #get webapps
    webapps = runcontext.get_extra_var('TOMCAT_WEBAPPS')
    
    if webapps is None:
        return ret_code,'The webapps is none.'
    
    ExceptionFile=''
    errMsg = ''
    for webapp in webapps:
        contexts = webapp['context.xml']
        host_name = webapp['host_name']
        context_path = webapp['context_path']
        
        #context.xml atleast have one
        if len(contexts) < 1:
            errMsg = '%s\n%s' % (errMsg,'Webapp %s%s: has no individual or default context.xml. ' % (host_name,context_path))
            continue
        #get the configuration value in the contexts in reverse order
        for context in contexts:            
            
            xmlTree = ET.parse(context)
            nodeContext = xmlTree.getroot()
            if nodeContext.tag != 'Context':
                nodes = xmlTree.findall('.//Context')
                if len(nodes) == 0:
                    continue
                else:
                    #only check the first node
                    nodeContext = nodes[0]
            
            #if confg
            if 'privileged' in nodeContext.attrib:
                value = nodeContext.attrib['privileged']
                if value.lower() == 'false':
                    tmp_vars["checkvalue"] = 'privileged=false'
                else:
                    auditresult = False
                    tmp_vars["checkvalue"] = 'privileged=true'
                    if context not in ExceptionFile:
                        ExceptionFile+=context+' '
                
    if auditresult == False:
        tmp_vars["checkvalue"] = 'privileged=true'
        errMsg = '%s %s' % (errMsg,'Webapp %s%s: <Context ... privileged= "true" />' % (host_name,ExceptionFile))
    
    if errMsg != '':
        ret_code = -1
        tmp_vars["checkvalue"] = errMsg
    else:
        ret_code = 0
        tmp_vars["policyresult"] = "pass"
        tmp_vars["checkresult"] = "pass"
    
    curtemplate = runcontext.get_template()
    rc1,out = curtemplate.render(runcontext.get_template_file('r_2_2_18.j2'),**tmp_vars)

    if rc1 == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out
        
    return ret_code,ret_msg
