# -*- coding: UTF-8 -*-
import xml.etree.ElementTree as ET


def get_tags():
    return ['2','2.2','2.2.19']

def run_task(runcontext):
    rc,out=run_audit(runcontext)
    return rc,out
    
def run_audit(runcontext):
    
    ret_code = 0
    ret_msg = ''
    filePath=''
    auditresult = True
    
    curtemplate=runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult"] = "failed"
    tmp_vars["checkvalue"] = ''
    
    ret_code = -2
    ret_msg = ''
    
    #get webapps
    webapps = runcontext.get_extra_var('TOMCAT_WEBAPPS')
    
    if webapps is None:
        return ret_code,'The webapps is none.'
    
    ExceptionFile = ""
    errMsg = []
    #first we process the context.xml
    for webapp in webapps:
        contexts = webapp['context.xml']
        host_name = webapp['host_name']
        context_path = webapp['context_path']
        
        #context.xml atleast have one
        if len(contexts) < 1:
            errMsg.append('Web App %s%s: context.xml does not exist. ' % (host_name,context_path))
            
        #get the configuration value in the contexts in reverse order
        for context in contexts:
            xmlTree = ET.parse(context)
            nodeContext = xmlTree.getroot()
            nodes = xmlTree.findall('.//Valve')
            if len(nodes) == 0:
                continue
            else:
                #check the nodes
                for nodeContext in nodes:
                    if 'resolveHosts' in nodeContext.attrib:
                        value = nodeContext.attrib['resolveHosts']
                        if value.lower() == 'false':
                            tmp_vars["checkvalue"] = 'resolveHosts=false'
                        else:
                            auditresult = False
                            tmp_vars["checkvalue"] = 'resolveHosts=true'
                            if context not in ExceptionFile:
                                ExceptionFile+=context+' '

    if auditresult == False:
        errMsg.append('Application %s%s: <Valve ... resolveHosts= \"true\" />' % (host_name,ExceptionFile))
    
    #second we process the server.xml
    serverFile = runcontext.get_extra_var('TOMCAT_GLOBAL_SERVER_FILE')
    auditresult = True
    if len(serverFile) < 1:
        errMsg.append('%s does not exist.' % (serverFile))

    else:
        xmlTree = ET.parse(serverFile)
        nodeContext = xmlTree.getroot()
        nodes = xmlTree.findall('.//Valve')
        if len(nodes) >= 0:
            #check the nodes
            for nodeContext in nodes:
                if 'resolveHosts' in nodeContext.attrib:
                    value = nodeContext.attrib['resolveHosts']
                    if value.lower() == 'false':
                        tmp_vars["checkvalue"] = 'resolveHosts=false'
                    else:
                        auditresult = False
                        tmp_vars["checkvalue"] = 'resolveHosts=true'
                        filePath+=","+serverFile

    if auditresult == False:
        errMsg.append('Application %s%s: <Valve ... resolveHosts= \"true\" />' % (host_name,filePath))
    
    if len(errMsg) != 0:
        ret_code = -1
        
        tmp_vars["checkvalue"] = '\\n'.join(errMsg)
    else:
        ret_code = 0
        tmp_vars["policyresult"] = "pass"
        tmp_vars["checkresult"] = "pass"
    
    curtemplate = runcontext.get_template()
    rc1,out = curtemplate.render(runcontext.get_template_file('r_2_2_19.j2'),**tmp_vars)
    
    if rc1 == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out
        
    return ret_code,ret_msg
