# -*- coding: UTF-8 -*-
import os
import json

def get_tags():
    return ['2','2.2','2.2.2']

def getOtherWebFiles(allwebs):
    owebs = []
    for webFile in allwebs:
        filelists = webFile.get('web.xml')
        filelists.pop()
        if len(owebs) == 0:
            owebs = filelists
        else:
            owebs.extend(filelists)
    return owebs

def run_task(runcontext):

    ret_code = -2
    ret_msg = '' 
    tmp_vars = {}
    tmp_vars['policyresult'] = 'failed'
    tmp_vars['checkresult1'] = 'failed'
    tmp_vars['checkvalue1'] = ''
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,'_ansible_module_name','xml_query')
    runcontext.set_mod_params_instance(ansible_params,'action',runcontext.get_parameter('action'))
    runcontext.set_mod_params_instance(ansible_params,'backupfile',os.path.join(runcontext.get_parameter('backup_path'),'r_2_2_2.json'))
    gwebxml = runcontext.get_extra_var('TOMCAT_GLOBAL_WEB_FILE')
    webxmls = getOtherWebFiles(runcontext.get_extra_var('TOMCAT_WEBAPPS'))
    webxmls.append(gwebxml)
    rwebs = webxmls[::-1]

    module=runcontext.get_module_file('xml_query.py')
    errMsg=""
    for webfile in rwebs:
        
        runcontext.set_mod_params_instance(ansible_params,'path',webfile)
        runcontext.set_mod_params_instance(ansible_params,'xpath','.//{ns}servlet/{ns}servlet-name')
        runcontext.set_mod_params_instance(ansible_params,'content','text')
        runcontext.set_mod_params_instance(ansible_params,'operation','exclude')
        runcontext.set_mod_params_instance(ansible_params,'value','webdav')    
        
        rc1,stdout1,stderr1 = runcontext.invoke_module(module, ansible_params)
        runcontext.sleep()
        runcontext.log_debug_invoke_result(rc1,stdout1,stderr1)
        resultjson1 = json.loads(stdout1)
    
        if 'failed' in resultjson1:
            ret_code = -2
            return ret_code,resultjson1['msg']
        values = "".join(resultjson1['items']['values'])
        if len(values) == 0:
            continue
        else:
            if "webdav" in values:
                errMsg = errMsg + '%s: \n    <servlet>\n        <servlet-name>webdav</servlet-name>\n        ...\n    </servlet>' % webfile


    if 0 == len(errMsg):
        tmp_vars['policyresult'] = 'pass'
        tmp_vars['checkresult1'] = 'pass'
        tmp_vars['checkvalue1'] = ''
        ret_code = 0
    else:
        ret_code = -1
        tmp_vars['policyresult'] = 'failed'
        tmp_vars['checkresult1'] = 'failed'
        tmp_vars['checkvalue1'] = errMsg
    
    curtemplate = runcontext.get_template()
    rc1,out = curtemplate.render(runcontext.get_template_file('r_2_2_2.j2'),**tmp_vars)

    if rc1 == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out
        
    return ret_code,ret_msg
