﻿# -*- coding: UTF-8 -*-
import re
import json

def get_tags():
    return ['2','2.2','2.2.20']

def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,"chdir",None)
    runcontext.set_mod_params_instance(ansible_params,"executable",None)
    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out
def run_audit(runcontext,ansible_params,module):
    curtemplate=runcontext.get_template()
    tomcat_home = runcontext.get_extra_var('TOMCAT_BASE')
    catalina_properties = tomcat_home + '/conf/catalina.properties'
    catalina_properties = runcontext.replace_inject_characters(catalina_properties)
    runcontext.log_debug("catalina_properties: %s" % catalina_properties)
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["scancommand1"] = '''value1=$(grep -n "package.access=" '''+ catalina_properties + ''' | awk -F: '{print $1}'); value2=$(($value1+1)); sed -n "$(echo $value1),$(echo $value2)p" ''' + catalina_properties + r'''  | grep "sun\." | grep -v "^[[:space:]]*#"'''
    tmp_vars["checkvalue1"] = ""

    tmp_vars["checkresult2"] = "failed"
    tmp_vars["scancommand2"] = '''value1=$(grep -n "package.access=" '''+ catalina_properties + ''' | awk -F: '{print $1}'); value2=$(($value1+1)); sed -n "$(echo $value1),$(echo $value2)p" ''' + catalina_properties + r'''   | grep "org\.apache\.catalina\." | grep -v "^[[:space:]]*#"'''
    tmp_vars["checkvalue2"] = ""

    tmp_vars["checkresult3"] = "failed"
    tmp_vars["scancommand3"] = '''value1=$(grep -n "package.access=" '''+ catalina_properties + ''' | awk -F: '{print $1}'); value2=$(($value1+1)); sed -n "$(echo $value1),$(echo $value2)p" '''+ catalina_properties + r'''  | grep "org\.apache\.coyote\." | grep -v "^[[:space:]]*#" '''
    tmp_vars["checkvalue3"] = ""

    tmp_vars["checkresult4"] = "failed"
    tmp_vars["scancommand4"] = '''value1=$(grep -n "package.access=" '''+ catalina_properties + ''' | awk -F: '{print $1}'); value2=$(($value1+1)); sed -n "$(echo $value1),$(echo $value2)p" '''+ catalina_properties + r'''   | grep "org\.apache\.tomcat\." | grep -v "^[[:space:]]*#"'''
    tmp_vars["checkvalue4"] = ""

    tmp_vars["checkresult5"] = "failed"
    tmp_vars["scancommand5"] = '''value1=$(grep -n "package.access=" '''+ catalina_properties + ''' | awk -F: '{print $1}'); value2=$(($value1+1)); sed -n "$(echo $value1),$(echo $value2)p" '''+ catalina_properties + r'''   | grep "org\.apache\.jasper" | grep -v "^[[:space:]]*#"'''
    tmp_vars["checkvalue5"] = ""

    ret_code = 0
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand1"])
    arc1,astdout1,astderr1=runcontext.invoke_module(module,ansible_params)
    runcontext.sleep()
    runcontext.log_debug_invoke_result(arc1,astdout1,astderr1)

    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand2"])
    arc2,astdout2,astderr2=runcontext.invoke_module(module,ansible_params)
    runcontext.sleep()
    runcontext.log_debug_invoke_result(arc2,astdout2,astderr2)

    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand3"])
    arc3,astdout3,astderr3=runcontext.invoke_module(module,ansible_params)
    runcontext.sleep()
    runcontext.log_debug_invoke_result(arc3,astdout3,astderr3)

    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand4"])
    arc4,astdout4,astderr4=runcontext.invoke_module(module,ansible_params)
    runcontext.sleep()
    runcontext.log_debug_invoke_result(arc4,astdout4,astderr4)

    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand5"])
    arc5,astdout5,astderr5=runcontext.invoke_module(module,ansible_params)
    runcontext.sleep()
    runcontext.log_debug_invoke_result(arc5,astdout5,astderr5)

    if arc1 != 0:
        return (-2, "Failed to invoke module: %s."%astdout1)
    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astderr1 = resultjson1["stderr"]
    match1_found=re.match(".+",astdout1)
    if match1_found == None:
        tmp_vars["checkvalue1"] = astdout1
    else:
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["checkvalue1"] = astdout1
    
    if arc2 != 0:
        return (-2, "Failed to invoke module: %s."%astdout2)
    resultjson2 = json.loads(astdout2)
    astdout2 = resultjson2["stdout"]
    astderr2 = resultjson2["stderr"]
    match2_found=re.match(".+",astdout2)
    if match2_found == None:
        tmp_vars["checkvalue2"] = astdout2
    else:
        tmp_vars["checkresult2"] = "pass"
        tmp_vars["checkvalue2"] = astdout2

    if arc3 != 0:
        return (-2, "Failed to invoke module: %s."%astdout3)
    resultjson3 = json.loads(astdout3)
    astdout3 = resultjson3["stdout"]
    astderr3 = resultjson3["stderr"]
    match3_found=re.match(".+",astdout3)
    if match3_found == None:
        tmp_vars["checkvalue3"] = astdout3
    else:
        tmp_vars["checkresult3"] = "pass"
        tmp_vars["checkvalue3"] = astdout3

    if arc4 != 0:
        return (-2, "Failed to invoke module: %s."%astdout4)
    resultjson4 = json.loads(astdout4)
    astdout4 = resultjson4["stdout"]
    astderr4 = resultjson4["stderr"]
    match4_found=re.match(".+",astdout4)
    if match4_found == None:
        tmp_vars["checkvalue4"] = astdout4
    else:
        tmp_vars["checkresult4"] = "pass"
        tmp_vars["checkvalue4"] = astdout4

    if arc5 != 0:
        return (-2, "Failed to invoke module: %s."%astdout5)
    resultjson5 = json.loads(astdout5)
    astdout5 = resultjson5["stdout"]
    astderr5 = resultjson5["stderr"]
    match5_found=re.match(".+",astdout5)
    if match5_found == None:
        tmp_vars["checkvalue5"] = astdout5
    else:
        tmp_vars["checkresult5"] = "pass"
        tmp_vars["checkvalue5"] = astdout5

    if tmp_vars["checkresult1"] == "pass" and tmp_vars["checkresult2"] == "pass" and tmp_vars["checkresult3"] == "pass" and tmp_vars["checkresult4"] == "pass" and tmp_vars["checkresult5"] == "pass":
        tmp_vars["policyresult"]="pass"
        ret_code = 0
    else:
        ret_code = -1
    rc,out=curtemplate.render(runcontext.get_template_file('r_2_2_20.j2'),**tmp_vars)
    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
