# -*- coding: UTF-8 -*-
import os
import json


def get_tags():
    return ['2','2.2','2.2.6']


def run_task(runcontext):

    ret_code = -2
    ret_msg = '' 
    tmp_vars = {}

    tmp_vars['policyresult'] = 'failed'
    tmp_vars['checkresult1'] = 'failed'
    tmp_vars['checkresult2'] = 'failed'
    tmp_vars['checkvalue1'] = ''
    tmp_vars['checkvalue2'] = ''

    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,'_ansible_module_name','xml_query')
    runcontext.set_mod_params_instance(ansible_params,'action',runcontext.get_parameter('action'))
    runcontext.set_mod_params_instance(ansible_params,'backupfile',os.path.join(runcontext.get_parameter('backup_path'),'r_2_2_6.json'))
    gserverxml = runcontext.get_extra_var('TOMCAT_GLOBAL_SERVER_FILE')
       
    module = runcontext.get_module_file('xml_query.py')
    runcontext.set_mod_params_instance(ansible_params,'path',gserverxml)
    runcontext.set_mod_params_instance(ansible_params,'xpath','.//{ns}Server')
    runcontext.set_mod_params_instance(ansible_params,'content','attribute')
    runcontext.set_mod_params_instance(ansible_params,'attribute','port')
    runcontext.set_mod_params_instance(ansible_params,'operation','exclude')
    runcontext.set_mod_params_instance(ansible_params,'value','8005')  
    rc1,stdout1,stderr1 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(rc1, stdout1, stderr1)
    runcontext.sleep()
    
    runcontext.set_mod_params_instance(ansible_params,'attribute','shutdown')
    runcontext.set_mod_params_instance(ansible_params,'operation','case insensitive not equal')
    runcontext.set_mod_params_instance(ansible_params,'value','shutdown')  
    rc2,stdout2,stderr2 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(rc2,stdout2,stderr2)
    runcontext.sleep()

    resultjson1 = json.loads(stdout1)
    resultjson2 = json.loads(stdout2)
    runcontext.log_debug(resultjson1)

    if 'failed' in resultjson1:
        ret_code = -2
        return ret_code,resultjson1['msg']
    if 'failed' in resultjson2:
        ret_code = -2
        return ret_code,resultjson2['msg']

    valuesport = resultjson1['items']['values'][0]
    if valuesport == "-1":
        tmp_vars['checkresult1'] = 'pass'
        tmp_vars['checkresult2'] = 'pass'
    else:

        if valuesport == "8005" or valuesport == "":
            tmp_vars['checkvalue1'] = "8005"
        else:
            tmp_vars['checkresult1'] = 'pass'
            tmp_vars['checkvalue1'] = ''.join(valuesport)

        valuescmd = list(resultjson2['items']['values'][0])
        d=u=l=o=0
        for i in valuescmd:
            if i.isdigit():
                d+=1
            elif i.isupper():
                u+=1
            elif i.islower():
                l+=1
            else:
                o+=1

        if len(valuescmd) < 12 or d == 0 or u == 0 or l == 0 or o ==0:
            tmp_vars['checkvalue2'] = ''.join(valuescmd)
        else:
            tmp_vars['checkresult2'] = "pass"
            tmp_vars['checkvalue2'] = ''.join(valuescmd)

    if tmp_vars['checkresult1'] == "pass" and tmp_vars['checkresult2'] == "pass":
        tmp_vars['policyresult'] = 'pass'
        ret_code = 0
    else:
        ret_code = -1
    
    curtemplate = runcontext.get_template()
    rc1,out = curtemplate.render(runcontext.get_template_file('r_2_2_6.j2'),**tmp_vars)

    if rc1 == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out
        
    return ret_code,ret_msg
