# -*- coding: UTF-8 -*-
import os
import re
import json

def get_tags():
    return ['2','2.2','2.2.8']


def run_task(runcontext):

    ret_code = -2
    ret_msg = '' 
    tmp_vars = {}
    tmp_vars['policyresult'] = 'failed'
    tmp_vars['checkresult1'] = 'failed'
    tmp_vars['checkvalue1'] = ''

    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,'_ansible_module_name','xml_query')
    runcontext.set_mod_params_instance(ansible_params,'action',runcontext.get_parameter('action'))
    runcontext.set_mod_params_instance(ansible_params,'backupfile',os.path.join(runcontext.get_parameter('backup_path'),'r_2_2_8.json'))
    gserverxml = runcontext.get_extra_var('TOMCAT_GLOBAL_SERVER_FILE')
       
    module = runcontext.get_module_file('xml_query.py')
    runcontext.set_mod_params_instance(ansible_params,'path',gserverxml)
    runcontext.set_mod_params_instance(ansible_params,'xpath','.//{ns}Connector')
    runcontext.set_mod_params_instance(ansible_params,'content','attribute')
    runcontext.set_mod_params_instance(ansible_params,'attribute','connectionTimeout')
    runcontext.set_mod_params_instance(ansible_params,'operation','not match')
    runcontext.set_mod_params_instance(ansible_params,'value','0|-1')  
    rc1,stdout1,stderr1 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(rc1, stdout1, stderr1)
    runcontext.sleep()

    resultjson1 = json.loads(stdout1)

    msgout = []
    items = resultjson1['items']['values']
    for item in items:
        if re.match("0|-1",item) != None:
            msgout.append("connectionTimeout="+item + " ")
    
    if 'failed' in resultjson1:
        ret_code = -2
        return ret_code,resultjson1['msg']

    if resultjson1['result'] == True:
        tmp_vars['checkvalue1'] = ' '.join(items)
        tmp_vars['checkresult1'] = 'pass'
    else:
        tmp_vars['checkvalue1'] = ''.join(msgout)
           
            
    if tmp_vars['checkresult1'] == "pass":
        tmp_vars['policyresult'] = 'pass'
        ret_code = 0
    else:
        ret_code = -1
    
    curtemplate = runcontext.get_template()
    rc1,out = curtemplate.render(runcontext.get_template_file('r_2_2_8.j2'),**tmp_vars)

    if rc1 == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out
        
    return ret_code,ret_msg
