﻿# -*- coding: UTF-8 -*-
import re
import json

def get_tags():
    return ['2','2.3','2.3.1']


def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,"chdir",None)
    runcontext.set_mod_params_instance(ansible_params,"executable",None)
    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out
def run_audit(runcontext,ansible_params,module):
    curtemplate=runcontext.get_template()
    tomcat_home = runcontext.get_extra_var('TOMCAT_HOME')
    tomcat_home = runcontext.replace_inject_characters(tomcat_home)
    runcontext.log_debug("tomcat_home: %s" % tomcat_home)
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["scancommand1"] = '''fadir(){ local this_dir=`pwd`; local child_dir="$1"; dirname "$child_dir"; cd $this_dir; };targetdir='''+tomcat_home+''';while [[ "$targetdir" != "/" ]];do tmp_mod=`stat -L --format=%a $targetdir`;if (( ("0$tmp_mod"&0022) != 0 ));then echo "$targetdir $tmp_mod";fi;targetdir=`fadir $targetdir`;done;tmp_mod=`stat -L --format=%a / `;if (( ("0$tmp_mod"&0022) != 0 ));then echo "/ $tmp_mod";fi;'''
    tmp_vars["checkvalue1"] = ""

    ret_code = 0
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand1"])
    arc1,astdout1,astderr1=runcontext.invoke_module(module,ansible_params)
    runcontext.sleep()
    if arc1 != 0:
        return (-2, "Failed to invoke module: %s."%astdout1)
    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astderr1 = resultjson1["stderr"]
    match_context = astdout1.replace("\n", " ")
    runcontext.log_debug_json(resultjson1)
    match1_found=re.match("^$",match_context)
    if match1_found == None:
        ret_code = -1
        tmp_vars["checkvalue1"] = astdout1
    else:
        ret_code = 0
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["checkvalue1"] = astdout1

    if tmp_vars["checkresult1"] == "pass":
        tmp_vars["policyresult"]="pass"
        
    rc,out=curtemplate.render(runcontext.get_template_file('r_2_3_1.j2'),**tmp_vars)
    if rc == False:
        return (-2,"Failed to render template.%s" % out)
    return ret_code,out
