﻿# -*- coding: UTF-8 -*-
import os
import json

def get_tags():
    return ['2','2.3','2.3.3']


def run_task(runcontext):
    
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,'_ansible_module_name','file_permission')
    runcontext.set_mod_params_instance(ansible_params,'action',runcontext.get_parameter('action'))
    runcontext.set_mod_params_instance(ansible_params,'backupfile',os.path.join(runcontext.get_parameter('backup_path'),'r_2_3_3.json'))
    runcontext.set_mod_params_instance(ansible_params,'other_r',False)
    runcontext.set_mod_params_instance(ansible_params,'other_w',False)
    runcontext.set_mod_params_instance(ansible_params,'other_x',False)
    runcontext.set_mod_params_instance(ansible_params,'group_r',False)
    runcontext.set_mod_params_instance(ansible_params,'group_w',False)
    runcontext.set_mod_params_instance(ansible_params,'group_x',False)
    runcontext.set_mod_params_instance(ansible_params,'owner_x',False)

    tomcatg_serverfile = runcontext.get_extra_var('TOMCAT_GLOBAL_SERVER_FILE')
    tomcatg_userfile = runcontext.get_extra_var('TOMCAT_GLOBAL_USER_FILE')
    tomcat_global_context_file = runcontext.get_extra_var('TOMCAT_GLOBAL_CONTEXT_FILE')
    tomcat_global_web_file = runcontext.get_extra_var('TOMCAT_GLOBAL_WEB_FILE')
    tomcat_global_login_properties_files = runcontext.get_extra_var('TOMCAT_GLOBAL_LOGGING_PROPERTIES_FILES')
    tomcat_webapps = runcontext.get_extra_var('TOMCAT_WEBAPPS')
    tomcat_global_catalina_policy_file = runcontext.get_extra_var('TOMCAT_GLOBAL_CATALINA_POLICY_FILE')
    tomcat_global_catalina_properties_file = runcontext.get_extra_var('TOMCAT_GLOBAL_CATALINA_PROPERTIES_FILE')
    
    #get all check files 
    checkfiles = []
    if None != tomcatg_serverfile:
        checkfiles.append(tomcatg_serverfile)
    if None != tomcatg_userfile:
        checkfiles.append(tomcatg_userfile)
    if None != tomcat_global_context_file:
        checkfiles.append(tomcat_global_context_file)
    if None != tomcat_global_web_file:
        checkfiles.append(tomcat_global_web_file)
    if None != tomcat_global_login_properties_files:
        checkfiles.append(tomcat_global_login_properties_files)
    if None != tomcat_global_catalina_policy_file:
        checkfiles.append(tomcat_global_catalina_policy_file)
    if None != tomcat_global_catalina_properties_file:
        checkfiles.append(tomcat_global_catalina_properties_file)
    if None != tomcat_webapps:
        for tomcat_webapp in tomcat_webapps:
            contexts = tomcat_webapp['context.xml']
            webs = tomcat_webapp['web.xml']
            logging_properties = tomcat_webapp['logging.properties']
            if None != contexts:
                for context in contexts:
                    if None != context:
                        checkfiles.append(context)
            if None != webs:
                for web in webs:
                    if None != web:
                        checkfiles.append(web)
            if None != logging_properties:
                for logging_propertie in logging_properties:
                    if None != logging_propertie:
                        checkfiles.append(logging_propertie)

    ret_code = -2
    ret_msg = ''
    checkFlag = True
    msgPass = []
    msgFail = []
    resultjson = ""
    tmp_vars = {}
    tmp_vars['policyresult'] = 'failed'
    tmp_vars['checkresult1'] = 'failed'
    tmp_vars['file_mode']=""

    module=runcontext.get_module_file('file_permission.py')
    for checkfile in checkfiles:
        if checkfile.strip() == "":
            continue
        runcontext.set_mod_params_instance(ansible_params,'path', checkfile)
        rc,stdout,stderr = runcontext.invoke_module(module, ansible_params)
        runcontext.sleep()
        runcontext.log_debug_invoke_result(rc,stdout,stderr)
        resultjson = json.loads(stdout)
        if 'failed' in resultjson:
            ret_code = -2
            ret_msg = resultjson['msg']
        elif 'result' in resultjson:
            
            result = resultjson['result']
            if result:
                if 'items' in resultjson:
                    if 'mode' in resultjson['items']:
                        msgPass.append(resultjson['items']['mode'])
            else:
                checkFlag = False
                if 'items' in resultjson:
                    if 'mode' in resultjson['items']:
                        msgFail.append(resultjson['items']['mode']+' ' + checkfile)
        else:
            ret_code = -2
            ret_msg = 'Result format is incorrect.'
    if checkFlag:
        ret_code = 0
        tmp_vars['policyresult'] = 'pass'
        tmp_vars['checkresult1'] = 'pass'
        tmp_vars['file_mode'] = '\n'.join(msgPass)
    else:
        ret_code = -1
        tmp_vars['policyresult'] = 'failed'
        tmp_vars['checkresult1'] = 'failed'
        tmp_vars['file_mode'] = '\n'.join(msgFail)

    curtemplate = runcontext.get_template()
    rc1,out = curtemplate.render(runcontext.get_template_file('r_2_3_3.j2'),**tmp_vars)
    if rc1 == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out

    return ret_code,ret_msg
