﻿# -*- coding: UTF-8 -*-
import os
import json
import re


def get_tags():
    return ['2','2.3','2.3.4']


def run_task(runcontext):
    ansibleParams = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansibleParams, "chdir", None)
    runcontext.set_mod_params_instance(ansibleParams, "executable", None)
    module = runcontext.get_module_file("shell.py")
    rc, out = run_audit(runcontext, ansibleParams, module)
    return rc, out


def run_audit(runcontext, ansibleParams, module):
    tmpVars = {}
    tomcatbase = runcontext.get_extra_var('TOMCAT_BASE')
    tomcatbase = runcontext.replace_inject_characters(tomcatbase)
    runcontext.log_debug("tomcatbase: %s" % tomcatbase)
    tmpVars["scancommand1"] = '''ps -wef | grep "catalina.base" | grep "%s" | grep -v grep | awk -F 'LOG_DIR' '{print $2}' | awk -F ' ' '{print $1}' | awk -F '=' '{print $2}' ''' % tomcatbase
    runcontext.set_mod_params_instance(ansibleParams, "command", tmpVars["scancommand1"])
    arc1, astdout1, astderr1 = runcontext.invoke_module(module, ansibleParams)
    runcontext.sleep()
    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astdout1 = astdout1.split("\n")
    astdout1 = "".join(astdout1).strip()
    match = re.match(".+", astdout1)

    tmpVars["scancommand2"] = r'''grep "directory=" %s/conf/server.xml | grep "directory=" | grep -vE "\s*#|^\s*$" ''' % tomcatbase
    runcontext.set_mod_params_instance(ansibleParams, "command", tmpVars["scancommand2"])
    arc2, astdout2, astderr2 = runcontext.invoke_module(module, ansibleParams)
    runcontext.sleep()
    resultjson2 = json.loads(astdout2)
    astdout2 = resultjson2["stdout"]
    match2 = "logs"
    if re.match(r'.+\s*directory="(.+)"', astdout2):
        match2 = re.match(r'.+\s*directory="(.+)"', astdout2).group(1)

    if match:
        logs_path = astdout1
    else:
        if os.path.isabs(match2):
            logs_path = match2
        else:
            logs_path = os.path.join(tomcatbase, match2)

    runcontext.log_debug("logs_path: %s" % logs_path)
    if os.path.islink(logs_path):
        logs_path = os.path.abspath(os.readlink(logs_path))
    ansibleParams = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansibleParams,'_ansible_module_name','file_permission')
    runcontext.set_mod_params_instance(ansibleParams,'action',runcontext.get_parameter('action'))
    runcontext.set_mod_params_instance(ansibleParams,'backupfile',os.path.join(runcontext.get_parameter('backup_path'),'r_2_3_4.json'))
    runcontext.set_mod_params_instance(ansibleParams,'path', logs_path)
    runcontext.set_mod_params_instance(ansibleParams,'other_r',False)
    runcontext.set_mod_params_instance(ansibleParams,'other_w',False)
    runcontext.set_mod_params_instance(ansibleParams,'other_x',False)
    runcontext.set_mod_params_instance(ansibleParams,'group_r',False)
    runcontext.set_mod_params_instance(ansibleParams,'group_w',False)
    runcontext.set_mod_params_instance(ansibleParams,'group_x',False)
    
    
    module=runcontext.get_module_file('file_permission.py')
    rc1,stdout,stderr = runcontext.invoke_module(module, ansibleParams)
    runcontext.sleep()
    resultjson = json.loads(stdout)

    
    retCode = -2
    retMsg = ''    
    
    #run failed
    if 'failed' in resultjson:
        retCode = -2
        retMsg = resultjson['msg']
    elif 'result' in resultjson:
        tmpVars = {}
        tmpVars['file_mode']=""
        curtemplate = runcontext.get_template()
        result = resultjson['result']
        if result == True:
            retCode = 0 
            tmpVars['policyresult'] = 'pass'
            tmpVars['checkresult1'] = 'pass'
            if 'items' in resultjson:
                if 'mode' in resultjson['items']:
                    tmpVars['file_mode'] = resultjson['items']['mode']
        else:
            retCode = -1
            tmpVars['policyresult'] = 'failed'
            tmpVars['checkresult1'] = 'failed'
            if 'items' in resultjson:
                if 'mode' in resultjson['items']:
                    tmpVars['file_mode'] = logs_path + " " + resultjson['items']['mode']
        
        
        
        
        
        rc1,out = curtemplate.render(runcontext.get_template_file('r_2_3_4.j2'),**tmpVars)
        
        if rc1 == False:
            retCode = -2
            retMsg = ('Failed to render template. %s' % out)
        else:
            retMsg = out
        
    else:
        retCode = -2
        retMsg = 'Result format is incorrect.'
        
    return retCode,retMsg
