﻿# -*- coding: UTF-8 -*-
import os
import json

def get_tags():
    return ['2','2.3','2.3.5']


def run_task(runcontext):
    
    tomcat_tmp_path = os.path.join(runcontext.get_extra_var('TOMCAT_BASE'),'temp')
    runcontext.log_debug("tomcat_tmp_path: %s" % tomcat_tmp_path)
    if os.path.islink(tomcat_tmp_path):
        tomcat_tmp_path = os.path.abspath(os.readlink(tomcat_tmp_path))
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,'_ansible_module_name','file_permission')
    runcontext.set_mod_params_instance(ansible_params,'action',runcontext.get_parameter('action'))
    runcontext.set_mod_params_instance(ansible_params,'backupfile',os.path.join(runcontext.get_parameter('backup_path'),'r_2_3_5.json'))
    runcontext.set_mod_params_instance(ansible_params,'path', tomcat_tmp_path)
    runcontext.set_mod_params_instance(ansible_params,'other_r',False)
    runcontext.set_mod_params_instance(ansible_params,'other_w',False)
    runcontext.set_mod_params_instance(ansible_params,'other_x',False)
    runcontext.set_mod_params_instance(ansible_params,'group_r',False)
    runcontext.set_mod_params_instance(ansible_params,'group_w',False)
    runcontext.set_mod_params_instance(ansible_params,'group_x',False)
    
    
    module=runcontext.get_module_file('file_permission.py')
    rc1,stdout,stderr = runcontext.invoke_module(module, ansible_params)
    runcontext.sleep()
    resultjson = json.loads(stdout)
    
    runcontext.log_debug_json(resultjson)
    
    ret_code = -2
    ret_msg = ''    
    
    #run failed
    if 'failed' in resultjson:
        ret_code = -2
        ret_msg = resultjson['msg']
    elif 'result' in resultjson:
        tmp_vars = {}
        tmp_vars['file_mode']=""
        curtemplate = runcontext.get_template()
        result = resultjson['result']
        if result == True:
            ret_code = 0 
            tmp_vars['policyresult'] = 'pass'
            tmp_vars['checkresult1'] = 'pass'
            if 'items' in resultjson:
                if 'mode' in resultjson['items']:
                    tmp_vars['file_mode'] = resultjson['items']['mode']
        else:
            ret_code = -1
            tmp_vars['policyresult'] = 'failed'
            tmp_vars['checkresult1'] = 'failed'
            if 'items' in resultjson:
                if 'mode' in resultjson['items']:
                    tmp_vars['file_mode'] = tomcat_tmp_path + " " + resultjson['items']['mode']

        
        rc1,out = curtemplate.render(runcontext.get_template_file('r_2_3_5.j2'),**tmp_vars)
        
        if rc1 == False:
            ret_code = -2
            ret_msg = ('Failed to render template. %s' % out)
        else:
            ret_msg = out
        
    else:
        ret_code = -2
        ret_msg = 'Result format is incorrect.'
        
    return ret_code,ret_msg
