﻿# -*- coding: UTF-8 -*-
import re
import json
import os


def get_tags():
    return ['2', '2.3', '2.3.6']


def run_task(runcontext):
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params, "chdir", None)
    runcontext.set_mod_params_instance(ansible_params, "executable", None)
    module = runcontext.get_module_file("shell.py")
    rc, out = run_audit(runcontext, ansible_params, module)
    return rc, out


def run_audit(runcontext, ansible_params, module):
    ret_code = -2
    ret_msg = ''
    curtemplate = runcontext.get_template()
    tomcatbase = runcontext.get_extra_var('TOMCAT_BASE')
    tomcatbase = runcontext.replace_inject_characters(tomcatbase)
    tomcat_webapps = os.path.join(tomcatbase, 'webapps')
    runcontext.log_debug("tomcatbase: %s" % tomcatbase)
    runcontext.log_debug("tomcat_webapps: %s" % tomcat_webapps)
    webapps_path = runcontext.get_extra_var('TOMCAT_WEBAPPS')
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params, '_ansible_module_name', 'file_permission')
    runcontext.set_mod_params_instance(ansible_params, 'action', runcontext.get_parameter('action'))
    runcontext.set_mod_params_instance(ansible_params, 'backupfile', os.path.join(runcontext.get_parameter('backup_path'), 'r_2_3_6.json'))

    runcontext.set_mod_params_instance(ansible_params, 'other_r', False)
    runcontext.set_mod_params_instance(ansible_params, 'other_w', False)
    runcontext.set_mod_params_instance(ansible_params, 'other_x', False)
    runcontext.set_mod_params_instance(ansible_params, 'group_w', False)

    checkStop = False
    for webapp_path in webapps_path:
        webapp_path_final = webapp_path['context_docBase']
        if webapp_path_final == 'default':
            ret_code = 0
            ret_msg = ''
            tmp_vars = {}
            tmp_vars["policyresult"] = "pass"
            tmp_vars["checkresult1"] = "pass"
            tmp_vars["checkvalue1"] = ""
            tmp_vars["scancommand1"] = '''stat --format="%s %s" %s/* 2>/dev/null''' % ("%n", "%a", tomcat_webapps)

            runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand1"])
            arc1, astdout1, astderr1 = runcontext.invoke_module(module, ansible_params)
            runcontext.log_debug_invoke_result(arc1, astdout1, astderr1)
            runcontext.sleep()

            if arc1 != 0:
                return -2, "Failed to invoke module: %s." % astdout1
            resultjson1 = json.loads(astdout1)
            astdout1 = resultjson1["stdout"]
            astderr1 = resultjson1["stderr"]
            runcontext.log_debug(resultjson1)

            tmp_vars["checkvalue1"] = astdout1
            astdout1 = astdout1.split("\n")
            for astdout in astdout1:
                match1 = re.match("^.+\s*[0-7][0-5]0$", astdout)
                if match1 is None:
                    ret_code = -1
                    tmp_vars["checkresult1"] = "failed"
                    tmp_vars["policyresult"] = "failed"
                    break

            rc, out = curtemplate.render(runcontext.get_template_file('r_2_3_6.j2'), **tmp_vars)

            if rc == False:
                ret_code = -2
                ret_msg = ('Failed to render template. %s' % out)
            else:
                ret_msg = out
        else:
            runcontext.set_mod_params_instance(ansible_params, 'path', webapp_path_final)
            module = runcontext.get_module_file('file_permission.py')
            rc1, stdout, stderr = runcontext.invoke_module(module, ansible_params)
            runcontext.sleep()
            runcontext.log_debug_invoke_result(rc1, stdout, stderr)
            resultjson = json.loads(stdout)

            tmp_vars = {}
            tmp_vars['checkvalue1'] = ""
            # run failed
            if 'failed' in resultjson:
                ret_code = -2
                ret_msg = resultjson['msg']
            elif 'result' in resultjson:
                curtemplate = runcontext.get_template()
                result = resultjson['result']
                if result == True:
                    ret_code = 0
                    tmp_vars['policyresult'] = 'pass'
                    tmp_vars['checkresult1'] = 'pass'
                    if 'items' in resultjson:
                        if 'mode' in resultjson['items']:
                            tmp_vars['checkvalue1'] = resultjson['items']['mode']
                else:
                    ret_code = -1
                    tmp_vars['policyresult'] = 'failed'
                    tmp_vars['checkresult1'] = 'failed'
                    if 'items' in resultjson:
                        if 'mode' in resultjson['items']:
                            tmp_vars['checkvalue1'] = webapp_path_final + " " + resultjson['items']['mode']
                    checkStop = True

                rc1, out = curtemplate.render(runcontext.get_template_file('r_2_3_6.j2'), **tmp_vars)

                if rc1 == False:
                    ret_code = -2
                    ret_msg = ('Failed to render template. %s' % out)
                else:
                    ret_msg = out

            else:
                ret_code = -2
                ret_msg = 'Result format is incorrect.'
            if True == checkStop:
                break

    return ret_code, ret_msg
