# -*- coding: UTF-8 -*-
import os
import json


def get_tags():
    return ['2', '2.3', '2.3.7']


def run_task(runcontext):

    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params, '_ansible_module_name', 'file_permission')
    runcontext.set_mod_params_instance(ansible_params, 'action', runcontext.get_parameter('action'))
    runcontext.set_mod_params_instance(ansible_params, 'backupfile', os.path.join(runcontext.get_parameter('backup_path'), 's_2_3_1.json'))
    serverxml = runcontext.get_extra_var('TOMCAT_GLOBAL_CONTEXT_FILE')
    runcontext.set_mod_params_instance(ansible_params, 'path', serverxml)
    runcontext.set_mod_params_instance(ansible_params, 'xpath', './/{ns}Valve')
    runcontext.set_mod_params_instance(ansible_params, 'content', 'attribute')
    runcontext.set_mod_params_instance(ansible_params, 'attribute', 'className')
    runcontext.set_mod_params_instance(ansible_params, 'operation', 'include')
    runcontext.set_mod_params_instance(ansible_params, 'value', 'org.apache.catalina.valves.RemoteAddrValve')

    module = runcontext.get_module_file('xml_query.py')
    rc1, stdout1, stderr1 = runcontext.invoke_module(module, ansible_params)
    runcontext.sleep()
    runcontext.log_debug(stdout1)
    runcontext.log_debug(stderr1)
    

    resultjson1 = json.loads(stdout1)
    ret_code = -1
    ret_msg = ''

    #run failed
    if 'failed' in resultjson1:
        ret_code = -2
        return ret_code, resultjson1['msg']

    tmp_vars = {}
    tmp_vars['policyresult'] = 'failed'
    tmp_vars['checkresult1'] = 'failed'
    tmp_vars['systemvalue1'] = ''

    if 'result' in resultjson1:
        result = resultjson1['result']
        tmp_vars['systemvalue1'] = '\n'.join(resultjson1['items']['values'])
        if result == True:
            tmp_vars['checkresult1'] = 'pass'
        else:
            tmp_vars['checkresult1'] = 'failed'

    if tmp_vars['checkresult1'] == 'pass':
        tmp_vars['policyresult'] = 'pass'
        ret_code = 0

    curtemplate = runcontext.get_template()
    rc1, out = curtemplate.render(runcontext.get_template_file('s_2_3_1.j2'), **tmp_vars)

    if rc1 == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out

    return ret_code, ret_msg
